# encoding: utf-8

class ImageUploader < CarrierWave::Uploader::Base

  require 'mime/types'
  include Sprockets::Helpers::RailsHelper
  
  process :set_content_type

  # Include RMagick or ImageScience support:
  # include CarrierWave::RMagick
  # include CarrierWave::ImageScience
  include CarrierWave::MiniMagick
    
  def set_content_type(*args)
    content_type = file.content_type == ('binary/octet-stream' || 'application/octet-stream') || file.content_type.blank? ? MIME::Types.type_for(original_filename).first.to_s : file.content_type
    self.file.instance_variable_set(:@content_type, content_type)
  end

  # Choose what kind of storage to use for this uploader:
  # storage :file
  # storage :s3

  # Override the directory where uploaded files will be stored.
  # This is a sensible default for uploaders that are meant to be mounted:
  def store_dir
    "#{model.id}"
  end

  # Provide a default URL as a default if there hasn't been a file uploaded:
  # def default_url
  #   "/images/fallback/" + [version_name, "default.png"].compact.join('_')
  # end
  def default_url
    Site.first.default_image.url rescue "-sign-in-logo.png"
  end
  
  # Process files as they are uploaded:
  # process :scale => [200, 300]
  #
  # def scale(width, height)
  #   # do something
  # end

  # Create different versions of your uploaded files:
  # version :thumb do
  #   process :scale => [50, 50]
  # end
  
  version :thumb do
    process :resize_to_limit => [200, 200]
  end

  # Add a white list of extensions which are allowed to be uploaded.
  # For images you might use something like this:
  # def extension_white_list
  #   %w(jpg jpeg gif png)
  # end

  # Override the filename of the uploaded files:
  # def filename
  #   "something.jpg" if original_filename
  # end
  
  def manipulate!
    cache_stored_file! if !cached?
    image = ::MiniMagick::Image.open(current_path)
    image = yield(image)
    image.write(current_path)
    ::MiniMagick::Image.open(current_path)
  rescue 
    nil
  end
  
end
